#!/cs/local/bin/ruby
# Outputs the parameters for each algorithm.

raise "Syntax for getting algorithm parameters: ruby algo_caller.rb <algo> -params" unless ARGV.length == 2 and ARGV[1] == "-params"

###########################################################################
# Output legal parameter values for PARAM_ILS.
###########################################################################
algo = ARGV[0]
raise "Syntax for getting algorithm parameters: ruby algo_caller.rb <algo> -params" unless ARGV[1] == "-params"
if algo == "saps"
	puts "alpha {1.01, 1.066, 1.126, 1.189, 1.256, 1.326, 1.4} [1.189]" #uniform on log scale between 1.01 and 1.4
	puts "rho {0, 0.17, 0.333, 0.5, 0.666, 0.83, 1} [0.5]" #uniform
	puts "ps {0, 0.033, 0.066, 0.1, 0.133, 0.166, 0.2} [0.1]" #uniform
	puts "wp {0, 0.01, 0.02, 0.03, 0.04, 0.05, 0.06} [0.03]" #uniform
elsif algo == "branin_function"
	puts "x {-5, -2.5, 0, 2.5, 5, 7.5, 10}[2.5]"
	puts "y {0, 2.5, 5, 7.5, 10, 12.5, 15}[7.5]"
elsif algo == "sls4mpe"
	results = []
	File.popen("sls4mpe -params"){|file| results = file.readlines}
	puts results
else
	puts "Wrapper not implemented for algorithms other than saps yet, in particular not for #{algo}"
	exit -1
end