#! /cs/local/bin/ruby#Interface for calibra. Computes the result for an algo.
require "param_reader.rb" #for state_string
@params, @domain, @default, $conditionals, @forbidden_combos = read_params("params.txt") # Need conditionals as global to enable strip_state in param_reader. HACK - shouldn't have to do this here, but need to call state_string in global_helper.


###########################################################################
#  Main - deal with inputs.
###########################################################################
algo = ARGV[0]
within_obj = ARGV[1]
obj = ARGV[2]
cutoff_time = ARGV[3].to_f
cutoff_length = ARGV[4].to_i
instance_seed_filename = ARGV[5]
N = ARGV[6].to_i
i = ARGV[7].to_i
param_array = ARGV[8].split.map{|x|x.strip}

p ARGV
p param_array 
puts "Algo: #{algo}"
puts "Minrun: #{i}"
puts "Maxrun: #{i}"
puts "Within instance obj: #{within_obj}"
puts "Obj combination: #{obj}"
puts "Cutoff time: #{cutoff_time}"
puts "Cutoff length: #{cutoff_length}"
puts "Instance set: #{instance_seed_filename.sub(/\/.*/,"")}"
puts "N: #{N}"

if algo == "saps"
#	params = {"alpha"=>param_array[0], "rho"=>param_array[1], "ps"=>param_array[2], "wp"=>param_array[3]}
	params = {"alpha"=>param_array[0], "ps"=>param_array[1], "rho"=>param_array[2], "wp"=>param_array[3]}
	#instanceset_name = "TRAINSET.DAT"
	#cutoff_time = 1
	#cutoff_length = 2147483647
	#numRuns = 1000
elsif algo == "branin_function"
	params = {"x"=>param_array[0], "y"=>param_array[1]}
	instanceset_name = "_"
	#cutoff_time = 100
	#cutoff_length = "_"
	#numRuns = 1000
elsif algo == "gls4mpe"
	params = {"b"=>param_array[0], "glsInterval"=>param_array[1], "glsPenMult"=>param_array[2], "glsSmooth"=>param_array[3], "pB"=>param_array[4]} 

	# ==================== CALIBRA for SLS4MPE: 4 cases, one for each acceptance criterion. Always fix initialization to MB and if ACC has another parameter, fix pert=2 (POTS)
elsif algo == "sls4mpe_rw" 
	algo = "sls4mpe"
	acc = 0  #0 is ACC_RW
	if param_array[0] == 0
		pert = 0
	else
		pert = 2
	end
	params = {"pert"=>pert, "pfix"=>param_array[1], "prel"=>param_array[2], "cf"=>param_array[3], "p"=>param_array[4], "b"=>1, "a"=>2, "vns"=>0, "acc"=>acc}
	#instanceset_name = "TRAINSET.DAT"
	#cutoff_time = 10
	#cutoff_length = "_"
	#numRuns = 1
elsif algo == "sls4mpe_better"
	algo = "sls4mpe"
	acc = 1  #1 is ACC_BETTER
	if param_array[0] == 0
		pert = 0
	else
		pert = 2
	end
	params = {"pert"=>pert, "pfix"=>param_array[1], "prel"=>param_array[2], "cf"=>param_array[3], "p"=>param_array[4], "b"=>1, "a"=>2, "vns"=>0, "acc"=>acc} 
	#instanceset_name = "TRAINSET.DAT"
	#cutoff_time = 10
	#cutoff_length = "_"
	#numRuns = 1
elsif algo == "sls4mpe_hybrid"
	algo = "sls4mpe"
	acc = 3 # 3 is ACC_HYBRID
	pert = 2
	params = {"pert"=>pert, "pfix"=>param_array[0], "prel"=>param_array[1], "cf"=>param_array[2], "p"=>param_array[3], "b"=>1, "a"=>2, "vns"=>0, "acc"=>acc, "an"=>param_array[4]} 
	#instanceset_name = "TRAINSET.DAT"
	#cutoff_time = 10
	#cutoff_length = "_"
	#numRuns = 1
elsif algo == "sls4mpe_lsmc"
	algo = "sls4mpe"
	acc = 7 # 7 is ACC_LSMC
	pert = 2
	params = {"pert"=>pert, "pfix"=>param_array[0], "prel"=>param_array[1], "cf"=>param_array[2], "p"=>param_array[3], "b"=>1, "a"=>2, "vns"=>0, "acc"=>acc, "T"=>param_array[4]} 
	#instanceset_name = "TRAINSET.DAT"
	#cutoff_time = 10
	#cutoff_length = "_"
	#numRuns = 1
else
	raise "Need to write calibra wrapper in cal_caller.rb for algorithm #{algo}"
end

require "global_helper.rb"
require "dbi_ils_accessor.rb"  if true #@db

$statsfile = "{$work_dir}/jobserver_calibra_stats.txt"
$total_cputime = 0
state_as_string = params.keys.sort.map{|param| param + "=" + params[param].to_s}.join(" ")

#=== Build @instances from file
@instances = []
File.open(instance_seed_filename){|file| 
   n=1;
    while line=file.gets and n<=N
	raise "Incorrect number of entries #{line.strip.split.length} in #{line}" unless line.strip.split.length >= 3  
	entries = line.strip.split
	seed = entries[0].to_i
	inst = entries[1]
	desired_qual = entries[2]
	reference = entries[3]
	@instances << {"seed"=>seed, "name"=>inst, "qual"=>desired_qual, "reference"=>reference, "resultForState"=>Hash.new}
	n += 1
    end
}


getAlgoResultsForEntryParamsPairs(algo, @instances.map{|entry| [entry, params]}, cutoff_time, cutoff_length, 2, true)    # 2 is jobserver
#test_result = combinationOfObjectiveFunctions(@algo, @overall_obj, test_results)
#instances, instancesSorted = getResultsForInstanceFile(algo, params, cutoff_time, cutoff_length, minRun, maxRun, instanceset_name, state_as_string,2,true)

require "algo_specifics.rb"

instancesSorted = @instances.map{|entry| entry["name"]}
objectives = getAllObjectives(algo, within_obj, @instances, instancesSorted, state_as_string, cutoff_time, cutoff_length)
outputCalibraObjectivesFairEval(algo, within_obj, obj, instancesSorted, objectives)
globalObj = getGlobalObjective(algo, within_obj, obj, @instances, state_as_string, cutoff_time, cutoff_length)[0]
puts "Total objective: #{globalObj}"