
/*==============================================================*/
/* Table: SAPS_CONFIGURATION (complete configuration of SAPS)
/*==============================================================*/
create table SAPS_CONFIGURATION
(
	ID         			int unsigned not null AUTO_INCREMENT,
	ALPHA				DECIMAL(8,4) not null,
	RHO					DECIMAL(8,6) not null,
	SMOOTH_PROB			DECIMAL(8,6) not null,
	RANDOM_WALK_PROB	DECIMAL(8,6) not null,
	primary key (ID),
	unique index configuration (ALPHA,RHO,SMOOTH_PROB,RANDOM_WALK_PROB)
);


/*==============================================================*/
/* Table: SAT4J_CONFIGURATION
/*==============================================================*/
create table SAT4J_CONFIGURATION
(
	ID         			int unsigned not null AUTO_INCREMENT,
	DSF				    enum('org.sat4j.minisat.constraints.ClausalDataStructureCB', 'org.sat4j.minisat.constraints.ClausalDataStructureCBWL', 'org.sat4j.minisat.constraints.ClausalDataStructureWL', 'org.sat4j.minisat.constraints.MixedDataStructureDaniel', 'org.sat4j.minisat.constraints.MixedDataStructureWithBinary', 'org.sat4j.minisat.constraints.MixedDataStructureWithBinaryAndTernary') not null,
	LEARNING			enum('org.sat4j.minisat.learning.ActiveLearning', 'org.sat4j.minisat.learning.FixedLengthLearning', 'org.sat4j.minisat.learning.LimitedLearning', 'org.sat4j.minisat.learning.MiniSATLearning', 'org.sat4j.minisat.learning.NoLearningButHeuristics', 'org.sat4j.minisat.learning.NoLearningNoHeuristics') not null,
	ACTIVITYPERCENT		DECIMAL(4,2),
	MAXLENGTH			int unsigned,
	LIMITLEARN			int unsigned,
	VARORDER			enum('org.sat4j.minisat.orders.JWOrder', 'org.sat4j.minisat.orders.MyOrder', 'org.sat4j.minisat.orders.PureOrder', 'org.sat4j.minisat.orders.VarOrderHeap', 'org.sat4j.minisat.orders.VarOrderHeapObjective') not null,
	PERIOD				int unsigned,
	SIMP				enum('NO_SIMPLIFICATION', 'SIMPLE_SIMPLIFICATION', 'EXPENSIVE_SIMPLIFICATION') not null,
	VARDECAY			DECIMAL(4,2) not null,
	CLADECAY			DECIMAL(6,4) not null,
	CONFLICTBOUNDINCFACTOR		DECIMAL(4,2) not null,
	INITCONFLICTBOUND		int unsigned not null,
	primary key (ID),
	unique index configuration (DSF,LEARNING,ACTIVITYPERCENT,LIMITLEARN,VARORDER,PERIOD,SIMP,VARDECAY,CLADECAY,CONFLICTBOUNDINCFACTOR,INITCONFLICTBOUND)
);
